//+------------------------------------------------------------------+
//|                                             Cromium - BETA 1.mq4 |
//|                                                     CROMIUM CORP |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "CROMIUM CORP"
#property link      "http://www.metaquotes.net"

#include <stdlib.mqh>
//---- input parameters
extern double    Lots=0.01;
extern double    TakeProfit=10.0;
extern double    MovingPeriod=150.0;
extern double    MovingShift=0.7;
extern bool      ReverseCondition     = false; // TRUE:buy-sell , sell-buy
double LastTrade=0,TotalLost;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
bool fnCloseTrades()
{
   int total=OrdersTotal();
   double myLost, myPrice,ma;
   int type=0;
   bool stat;
   
   
   for( int cnt=0;cnt<total;cnt++ )
   {
      ma = iMA(NULL, 0, MovingPeriod, MovingShift, MODE_SMA, PRICE_CLOSE, 0);
      
      
      type=0;
      if( (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES)) == False )
      {
         Print( "OrderSelect failed:", GetLastError() );
         return(-1);
      }
      //
      RefreshRates();
      switch( OrderType() )
      {
         case OP_BUY:
            
            myPrice=NormalizeDouble((ma-0.05),1);
            myLost=OrderOpenPrice()-myPrice;
            break;
            
         case OP_SELL:
           
            myPrice=NormalizeDouble((ma+0.05),1);
            myLost=myPrice-OrderOpenPrice();
            break;
      
         default:
            type=1;
            break;      
      
      }
      
      if( type == 1 )
         stat = OrderDelete(OrderTicket());
      else
         
         stat = OrderClose( OrderTicket(), OrderLots(), myPrice, 0, Yellow );
         
      if( stat == false )
      {
         int err=GetLastError();
         Print("OrderClose failed, error=", err, ": ", ErrorDescription(err) );
      }
      else
         Print( "OrderClose OrderTicket:", OrderTicket() );   
         TotalLost=TotalLost+myLost;
   }
   return(stat);
}



//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
double CheckOpenTrade()
{
   int
      cnt         = 0;
      

   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==12345)
      {
         if(OrderType()==OP_BUY ) LastTrade = OrderOpenPrice();
         if(OrderType()==OP_SELL) LastTrade = OrderOpenPrice();
      }         
   }
   return(LastTrade);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double ma, sell, buy;
   int ticket, total, price;
   
   ma = iMA(NULL, 0, MovingPeriod, MovingShift, MODE_SMA, PRICE_CLOSE, 0);
      
   if (Bid<ma)
      {sell=NormalizeDouble(Bid,1);
       price=sell/Point;
       if (fnCloseTrades())
       {
       if(price%10==0)
       {
       ticket = OrderSend(Symbol(), OP_SELL, Lots+(TotalLost/TakeProfit)*Point, sell, 0, 0, sell - TakeProfit*Point, "SAPUTRA", 12345, 0, Red);
       
       if (ticket > 0)
         {
          if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
          Print("SELL order opened : ", OrderOpenPrice());
          TotalLost=0;
         }
       else 
          Print("Error opening SELL order : ",GetLastError()); 
          return(0);
       }
       }
       sell=NormalizeDouble(Bid,1);
       price=sell/Point;
       if(price%10==0)
       {
       if (CheckOpenTrade()!= sell)
       {  
       ticket = OrderSend(Symbol(), OP_SELL, Lots, sell, 0, 0, sell - TakeProfit*Point, "SAPUTRA", 12345, 0, Red);
       
       if (ticket > 0)
         {
          if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
          Print("SELL order opened : ", OrderOpenPrice());
          TotalLost=0;
         }
       else 
          Print("Error opening SELL order : ",GetLastError()); 
          return(0);
       }
       }
       else return(0);      
      } 
     
   if (Ask>ma)
      {
       buy=NormalizeDouble(Ask,1);
       price=buy/Point;
       if(fnCloseTrades())
       {
       
       if(price%10==0)
       {
       ticket = OrderSend(Symbol(), OP_BUY, Lots+(TotalLost/TakeProfit)*Point, buy, 0, 0, buy + TakeProfit*Point, "SAPUTRA", 12345, 0, Green);
            
       if (ticket > 0)
         {
          if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
          Print("BUY order opened : ",OrderOpenPrice());   
         }
       else 
          Print("Error opening BUY order : ", GetLastError()); 
          return(0);
       }
       }
       else
       {
       if(price%10==0)
       {
       if (CheckOpenTrade()!= buy)
       {
       ticket = OrderSend(Symbol(), OP_BUY, Lots, buy, 0, 0, buy + TakeProfit*Point, "SAPUTRA", 12345, 0, Green);
            
       if (ticket > 0)
         {
          if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
          Print("BUY order opened : ",OrderOpenPrice());   
         }
       else 
          Print("Error opening BUY order : ", GetLastError()); 
          return(0);
       } else return(0);
       }
       }
       }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+